#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void exit_cave(void);
void temple_exploded(void);
void house_burning(void);
void show_ending_logo(void);
void go_ending(void);

int area_cave(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ϼˤǤƶΤ褦"
                    "˸롣"
                    "ɤ鳰˽Ф줽");
            return 1;
		case vi_forward:
		case vi_exit:
			message("¤ϡĤäɥ̤ȯ벻ʹƤ롣"
					"ʤϱɤ褦ˤơƶνиؤä");
            message("");
            exit_cave();
            return 1;
		case vi_backward:
			message("¤ϤäФäƤơ"
					"ȤƤ֤ʤ");
//			move_area(ai_temple);
            return 1;
        default:
            break;

        }
        break;
    case ni_floor:
    case ni_wall:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void exit_cave(void){
    move_area(ai_under_cliff);
    set_wait_return_callback(temple_exploded);
}
void temple_exploded(void){
    move_area(ai_under_cliff);
    //    message("ƶФȡϳߤä");
    message(""
            "ƶ椫ϡʤȯ³"
            "䤬粻ȶˡ˱줬Ωä");
    Set(temple_exploded);
    set_wait_return_callback(house_burning);
}
void house_burning(void){
    message(""
            "뤦ˡߤ뤫줬夬ꡢ"
            "ޤʤФμ꤬夬ä"
            "ơޤ路Τ˻ۤƤߤϡ"
            "٤Ƥ˾ƤƤä");
    Set(house_burning);
    set_wait_return_callback(show_ending_logo);
}
void show_ending_logo(void){
    Set(the_end);
    set_wait_return_callback(go_ending);
}
void go_ending(void){
    move_to_ending();
}
