#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_cellar(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("¦ˤϡؾ夬%nl롣"
                    "̤ˤϾ%nl롣",
                    ni_stairs, ni_door);
            message("¦ɤ礭졢꤬Ƥ롣");
            return 1;
		case vi_up:
		case vi_left:
		case vi_exit:
            Reset(save_forbidden);
            EnterDoor(laundry, laundry_cellar);
            return 1;
		case vi_right:
            move_area(ai_corridor_0f);
            return 1;
        case vi_forward:
            EnterDoor(boiler_room, boiler_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
			return 1;
		}
        break;
    case ni_stairs:
        switch (vid){
        case vi_look:
        case vi_examine:
            break;
        case vi_use:
        case vi_up:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("ξˤ%nlƤ롣", ni_gun);
            return 1;
        default:
            break;
        }
        break;
    case ni_gun:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("äˤ줿ΤƿȤˤȶʤäƤ롣");
            return 1;
        case vi_get:
            message("äƹԤäƤΩˤʤ");
            return 1;
        case vi_use:
            message("ȤƤƤ֤ǤϤʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

