#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_0f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            //            message("ظˤϡϲؤ³%nl롣",
            //                    ni_door);
            return 1;
		case vi_forward:
            move_area(ai_temple);
            return 1;
		case vi_backward:
		case vi_exit:
            move_area(ai_cellar);
            return 1;
        default:
            break;
        }
        break;
    case ni_floor:
        switch(vid){
        case vi_look:
        case vi_examine:
            message("ˤ䤫ʲˤʤäƤ롣");
            if (Not(hat_taken)){
                message("ξˤ%nlƤ롣",
                        ni_hat);
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_hat:
        ReturnIfHasItem;
        switch(vid){
        case vi_get:
            command_get_item(nid, fi_hat_taken);
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

