#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_fl(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("ϭǱޤƤ롣");

            message("ظȱ¦%nw%nw\\",
                    ni_back_door, ni_right_door);
            if (Is(hall_left_door_opened) &&
                Is(guestroom_1f_door_opened))
            {
                message("ꡢ줾츼إۡȵҼ̤Ƥ롣");
            }
            else if (Is(hall_left_door_opened)){
                message("ꡢԤϸإ̤ۡƤ롣");
            }
            else if (Is(guestroom_1f_door_opened)){
                message("ꡢԤϵҼ̤Ƥ롣");
            }
            else {
                message("롣");
            }
            return 1;
			if (Is(hall_left_door_opened)){
                message("ظˤϸإ̤ۡ%nw롣", ni_door);
            }
            else {
                message("ظˤ%nw롣", ni_door);
            }
            return 1;
        case vi_forward:
            move_area(ai_corridor_1f_bl);
            return 1;
		case vi_backward:
            EnterDoor(entrance_hall, hall_left);
            return 1;
        case vi_right:
            EnterDoor(guestroom_1f, guestroom_1f);
			return 1;
        default:
            break;
        }
		break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
    case ni_window:
        break;
	case ni_door:
	    msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
		break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

