#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_corridor_1f_fr(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("ϭǺޤƤ롣");
            message("ظȺ¦%nw%nw\\",
                    ni_back_door, ni_left_door);
            if (Is(hall_right_door_opened) &&
                Is(bathroom_door_opened))
            {
                message("ꡢ줾츼إۡἼ̤Ƥ롣");
            }
            else if (Is(hall_right_door_opened)){
                message("ꡢԤϸإ̤ۡƤ롣");
            }
            else if (Is(bathroom_door_opened)){
                message("ꡢԤϸإ̤ۡƤ롣");
            }
            else {
                message("롣");
            }
            return 1;
        case vi_forward:
            move_area(ai_corridor_1f_mr);
            return 1;
        case vi_backward:
            if (Not(hall_right_door_unlocked)){
                msg_door_unlocked_by_opening();
                Set(hall_right_door_unlocked);
            }
            EnterDoor(entrance_hall, hall_right);
            return 1;
        case vi_left:
            EnterDoor(bathroom, bathroom);
            return 1;
        case vi_exit:
            message("뤫鳰˽Ф줽");
            return 1;
        default:
            break;
        }
		break;
    case ni_corridor:
        switch (vid){
        case vi_look:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
        switch(vid){
        case vi_look:
			message("¦ɤˤ뤬¤Ǥ롣");
			message("βˤʤˤ񤤤Ƥ롣");
			return 1;
        case vi_examine:
			message("βˡɤʸƱΡ"
                    "㿧ѿߤ롣");
			return 1;
        case vi_read:
			message("ֽФʡפȽ񤫤Ƥ롣");
			return 1;
		default:
			break;
		}
		break;
    case ni_window:
        switch(vid){
        case vi_look:
			message("ϳƤ롣");
			return 1;
        case vi_examine:
			message("夲줿Ȥ褯ȡ"
                    "¦ʪΤ褦˱ԤٹƤ롣");
			return 1;
        case vi_exit:
            die_exiting_window();
			return 1;
        case vi_open:
			message("⤦Ƥ롣");
			return 1;
        case vi_close:
			message("ȤӤĤƤΤǤĤޤʤ");
			return 1;
		default:
			break;
		}
		break;
    case ni_door:
		msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
		break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_floor:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

