#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_under_tree(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch (vid){
        case vi_look:
            DescribeArea;
			message("礭%nlΩäƤ롣",
					ni_tree);
            return 1;
        case vi_left:
            move_area(ai_backdoor);
            return 1;
        case vi_right:
            move_area(ai_garden);
            return 1;
		case vi_up:
			message("ϤȤ˻ޤʤ"
					"Ф̾ͤϢƤ뤫"
					"ҤǤѰդʤ̵");
			return 1;
        default:
            break;
        }
        break;
	case ni_tree:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("ޤΰܤͤˤäƲߤǤ롣");
			return 1;
		case vi_up:
			RedoArea(vid, ni_invalid);
		default:
			break;
		}
		break;
	case ni_window:
		switch (vid){
		case vi_look:
		case vi_examine:
			RedoArea(vid, ni_tree);
			return 1;
		case vi_open:
		case vi_close:
		case vi_push:
		case vi_pull:
		case vi_move:
		case vi_remove:
		case vi_hit:
		case vi_kick:
		case vi_destroy:
		case vi_enter:
		case vi_up:
			message("˼꤬Ϥʤ");
			return 1;
		default:
			break;
		}
		break;
    case ni_house:
	case ni_wall:
		break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
