/*
  ʸϴؿ饤֥
  Ver0.01
  2014.9.12
*/
#ifndef INPUT_LINE_H
#define INPUT_LINE_H
#include <jstr.h>
#include <roman_conv.h>

#define PROMPT_WIDTH_MAX 64

int input_line_init(int width_max);
char *input_line_get_line(void);
int input_line_get_input(char *input);
int input_line_get_byte(void);
int input_line_get_width(void);
int input_line_get_chr_num(void);
int input_line_get_word_num(void);
int input_line_is_tail_spc(void);
int input_line_clear(void);

#ifdef DEBUG
void input_line_print_line(void);
#endif

int input_line_backspace(void);
int input_line_delete_word(void);
int input_line_append_chr(char chr);
int input_line_append_code(unsigned int code, int byte);
int input_line_set_str(char *str);
int input_line_append_str(char *str);

int input_line_set_prompt(char *new_prompt);
int input_line_set_cursor(char cursor);

#endif
