/*
  ޻Ѵбʸϴؿ饤֥
  Ver0.01
  2014.9.18
*/
#ifndef ROMAN_INPUT_LINE_H
#define ROMAN_INPUT_LINE_H
#include <jstr.h>
#include <roman_conv.h>
#include <input_line.h>

typedef enum {
    im_english, im_hiragana, im_katakana
} roman_input_line_mode_t;


int roman_input_line_init(int byte_max);
roman_input_line_mode_t roman_input_line_get_mode(void);
void roman_input_line_set_mode(roman_input_line_mode_t mode);
char *roman_input_line_get_line(void);
int roman_input_line_get_input(char *input);
int roman_input_line_get_byte(void);
int roman_input_line_get_width(void);
int roman_input_line_get_roman_byte(void);
int roman_input_line_get_chr_num(void);
int roman_input_line_get_word_num(void);
int roman_input_line_is_tail_spc(void);
int roman_input_line_clear(void);

#ifdef DEBUG
void roman_input_line_print_line(void);
#endif

int roman_input_line_backspace(void);
int roman_input_line_delete_word(void);
int roman_input_line_append_chr(char chr);
int roman_input_line_terminate(void);
int roman_input_line_append_code(unsigned int code, int byte);
int roman_input_line_set_str(char *str);
int roman_input_line_append_str(char *str);

int roman_input_line_set_prompt(char *new_prompt);
int roman_input_line_set_cursor(char new_cursor);


#endif
