#ifndef STATUS_H
#define STATUS_H
#include <stdio.h>
#include "term.h"
#include "area.h"

#define ITEM_MAX 256
#define FLAG_SEQUENCE_MAXLEN 16


// Ƽե饰ID
// 礷0ǽǤ褦ˡ֤٤Ƶˤʤ褦롣
// 񤷤ʤƥϽե饰ǷѤǤ뤿ᡢǼե饰Ѱդʤ
// (û륱Ǥϼե饰Ѱդ)
// ''ϥꥢ̵طʥե饰
// ''϶ŪONˤʤ륤٥ȥե饰
typedef enum {
    fi_invalid = -1,
    fi_begin = 0,
    fi_begin_game_flags = 0,
	fi_save_forbidden = fi_begin_game_flags, // !֥ޥɤػߤƤ

    fi_entrance_unlocked,       // ؤ⤬Ƥ
    fi_mailbox_opened,          // ͹ؼƤ
    fi_mailbox_has_closed,      // ͹ؼĤȤ(ٳĤ)
    fi_leaflet_taken,           // 饷
    fi_leaflet_read,
    fi_medal_taken,             // 

	fi_newspaper_looked,        // ʹ򸫤(look hat˱ƶ)
	fi_newspaper_read,          // ʹɤ

	fi_flowerpot_moved,         // ȭư
    fi_flowerpot_destroyed,     // ȭ
	fi_brass_key_taken,         // 﫤θ
	fi_wooden_key_taken,        // ڤθ
    fi_entered_house,           // ߤä

    //    fi_start_phone_call,        // äĤϤ᤿
	fi_phone_call_continued,    // äĤ³Ƥ(ʸON)
	fi_stop_phone_call,         // äĤ꽪ä
	fi_phone_call_stopped,      // äĤ꽪ä(ʸON)
	fi_phone_call_answered,     // äȤäʹ
	fi_photo_checked,           // ̿򸫤
	fi_man_checked,             // ̿򸫤
	fi_woman_checked,           // ̿ν򸫤
	fi_girl_checked,            // ̿ξ򸫤
	fi_boy_checked,             // ̿ξǯ򸫤
	fi_clock_working,			// פưƤ()
	fi_clock_adjusted,          // פ㥹Ȥ˹碌(פĤOFF)
	fi_clock_striking,          // פĤ
	fi_clock_bird_appeared,     // Ļ줿(˲)
	fi_toy_bird_taken,          // Ļ
    fi_silver_key_found,        // ϧǳ̤Ĵ٤ƶθȯ
    fi_silver_key_taken,        // θꤷ
    fi_fireplace_message_read,  // ϧΥåɤ
    fi_fossil_taken,            // Фꤷ

    //    fi_card_taken,        // 纴Υ⤬񤫤줿ȥפȤä
    fi_sanders_note_read,       // 纴Υ⤬񤫤줿ȥפɤ
	fi_billiard_ball_lost,      // ӥ䡼˥ӥ䡼ɥܡ줿
	fi_essay_found,             // ǯκʸ򸫤Ĥ
	fi_essay_taken,             // ǯκʸȤä
    fi_essay_read,




    fi_dragon_taken,
    fi_golden_key_taken,
    fi_guestroom_1f_chair_moved,
    fi_guestroom_1f_table_moved,
    fi_guestroom_1f_cabinet_opened,


    fi_bathtub_empty,           // ̾Τή
    fi_bathroom_1f_message_read,// ΢Υåɤ
    fi_mirror_taken,            // 
    fi_mirror_read,             // ɤ
    fi_glasses_taken,           // 
    fi_duck_taken,              // ҥ
    fi_toilet_used,             // ȥȤä

    fi_storage_table_moved,     // ʪ֤αΥơ֥ư
    fi_storage_drawers_closed,  // ʪ֤ýڤΰФ򤷤᤿
    fi_sponge_wet,              // ݥ󥸤ˤĤǨ餷
    fi_fishing_rod_with_sponge, // Ȥݥ󥸤ĤˤʤäƤ
    fi_lantern_taken,           // 󥿥
    fi_lantern_lit,             // 󥿥äƤ롣

    fi_oven_opened,             // ֥󤬳Ƥ
    fi_chicken_taken,           // ֥ηܤä(Ȥϸ¤ʤ)

    fi_chicken_put,             // Ʋ˥֤

    fi_dining_put_man,          // ƲΤ줾ʤˤʤˤ֤Ƥ
    fi_dining_put_woman,
    fi_dining_put_girl,
    fi_dining_put_boy,          // ֤ǷΤΤǿǤ٤
                                // ƥŪ˥ե饰Ϥ٤ƽ֤Ǥ
                                // fi_dining_notput_boyʤɤȤ
                                // 崰åݤʤΤǡ
                                // area.c:start_game()ǶŪĴ

    fi_dining_glasses_put,      // Ʋ˴֤
    fi_dining_necklace_put,     // Ʋ˥ͥå쥹֤
    fi_dining_plush_cat_put,    // Ʋˤ̤ߤ֤
    fi_dining_large_robot_put,  // Ʋ˵ܥåȤ֤

    fi_dining_toy_swordman_put, // Ʋ˷Τδ֤
    fi_dining_toy_lion_put,     // Ʋ˥饤δ֤
    fi_dining_toy_bird_put,     // ƲĻδ֤
    fi_dining_robot_put,        // Ʋ˥ܥåȤ֤
    fi_dining_toy_dragon_put,   // Ʋ˥ɥ饴δ֤

    fi_dining_fishing_rod_put,  // ƲȤ֤
    fi_dining_bottle_put,       // 
    fi_dining_fossil_put,       // 
    fi_dining_screwdriver_put,  // 
    fi_dining_girl_doll_put,    // 
    fi_dining_witch_doll_put,   // 
    fi_dining_marble_put,       // 
    fi_dining_poker_put,        // 
    fi_dining_billiard_ball_put,// 
    fi_dining_rubber_duck_put,  // 
    fi_dining_slingshot_put,  // 
    fi_dining_ladder_put,  // 
    fi_dining_diary_put,  // 
    fi_dining_score_put,  // 
    fi_dining_origami_plane_put,  // 
    fi_dining_essay_put,  // 
    fi_dining_paper_put,  // 
    fi_dining_lantern_put,  // 
    fi_dining_mirror_put,  // 
    fi_dining_medal_put,  // 

    fi_toy_swordman_taken,      // ΤΤä
	fi_ghost_appeared,          // Ʋ˰Ȥ줿
	fi_candle_lit,              // ϹĤ
	fi_candle_taken,            // Ϲä
	fi_chicken_bone_taken,      // Ļιä

	fi_portrait_eyes_right,     // ܤ
	fi_portrait_removed,        // 򳰤
	fi_portrait_has_removed,        // 򳰤Ȥ
    fi_start_armor_to_guestroom,       // 2FҼ˳Ф륤٥ȳ
    fi_armor_left_study_to_guestroom,  // ҼФ2FҼ˸ä
    fi_armor_moving_to_guestroom, // 2FҼ˳ư
    fi_armor_in_guestroom,      // 2FҼ˳줿
    fi_armor_restoring_guestroom, // 2FҼ

    fi_armor_moving, // ֤ΥƤ

    fi_start_armor_from_guestroom,
    fi_armor_moving_from_guestroom,
    fi_armor_returning_study,


    fi_guestroom_2f_book_moved, // ơ֥ξܤư
    fi_logbook_found,           // Ǹ򸫤Ĥ
    //    fi_logbook_taken,           // ǸȤä
    fi_logbook_read,             // Ǹɤ
    fi_guestroom_2f_chair_moved, // ýڤΰػҤư
    fi_guestroom_2f_table_moved, // ýڤΥơ֥ư
    fi_guestroom_2f_cabinet_opened,
    fi_sponge_taken,
    fi_bottle_taken,

	fi_washer_opened,           // 򳫤
	fi_dryer_opened,            // 絡򳫤
	fi_bronze_key_found,        // Ƽθ򸫤Ĥ
	fi_bronze_key_taken,        // Ƽθ
    fi_dog_stood_up,            // Ω夬ä 
    fi_dog_gone,                // ¤äƤޤä
    fi_belt_taken,              // ؤ
    fi_fishing_rod_taken,       // Ȥ
    fi_poker_taken,             // Ф

    fi_attacked_on_2f,          // 2Fǽ줿Ȥ

    fi_ladder_taken,            // Ҥʥ٥åɤ鳰(Ȥϸ¤ʤ)
    fi_treasure_chest_moved,    // Ȣư
    fi_treasure_chest_unlocked, // Ȣ
    fi_treasure_chest_broken,   // Ȣθ
    fi_treasure_chest_opened,   // Ȣ򳫤
    fi_billiard_ball_taken,     // ӥ䡼ɤζ̤
    fi_slingshot_taken,         // 줿Ѥ󤳤
	fi_slingshot_repaired,      // Ѥ󤳤

    fi_mattress_moved,          // ʥ٥åɾʤΥޥåȥ쥹ư
    fi_diary_taken,             // 
    fi_diary_read,
    fi_diary_examined,
    fi_plush_cat_taken,         // ǭΤ̤ߤ

    fi_wardrobe_opened,			// ýڤ⤬Ƥ
    fi_saw_shadow,              // Ƥ򸫤(ĤäΤǻ˴)
    fi_dressing_table_unlocked,
    fi_dressing_table_opened,
    fi_branch_taken,
    fi_necklace_taken,

    fi_start_shadow,            // 2Fαơ٥ȷ󳫻
	fi_shadow_appeared,         // Ƥи
	fi_shadow_behind_door,      // Ƥ׿Υɥθ
	fi_shadow_in_room,          // ƤäƤ
    fi_shadow_attack,           // ƤäƤ
    fi_shadow_wandering,        // Ƥ򤵤ޤäƤ
    fi_shadow_gone,             // ƤԤäƤޤä

    fi_bedroom_drawers_opened,  // ýڤΰФ򳫤
    fi_marble_found,            // ٥åɤβ˥ӡ̤ȯ
    fi_marble_taken,            // ӡ̤

    fi_start_armor_to_study,    // ǽݤεưե饰
                                // ǳ٥Ȥ
                                // ե饰ȤäƤʤ
                                // ¾Υե饰(i.e. armor_moving)
                                // ˽򤤤äȤϤΥե饰ΩƤƤ
                                // 꼡armor_in_study˰ܹԤ
    fi_armor_in_study,

    fi_study_library_door_closed,
    fi_study_desk_unlocked,
    fi_study_desk_opened,
//    fi_amulet_taken,
    fi_screwdriver_taken,
    //    fi_postcard_taken,
    fi_postcard_read,
    //	fi_notebook_taken,
    fi_study_notebook_read,

    fi_armor_dead, 

    fi_armor_in_library,
    fi_armor_restoring_library,
    fi_bookshelf_book_removed,
    fi_bookshelf_unlocked,
    fi_bookshelf_moved,
    fi_diary_piece_read,
    //    fi_easy_necromancy_taken,
    fi_easy_necromancy_read,  // Ѥɤ
    fi_library_ladder_set,
    fi_origami_plane_taken,
    fi_fossil_set,            // Ф޽񼼤֤
    fi_armor_crushed,         // ž
    fi_armor_reviving,        // ž
    fi_armor_revived,         // žΩ夬ä

	fi_pocket_notebook_dropped, // !ΤĴ٤ƼĢ
    fi_secret_room_note_read,   // !ޥɥʥɤΰɤ
    fi_candle_put,              // ŤϹ
    fi_magic_circle_invoked,    // ˡΤư
    fi_secret_room_letter_read, // !ɤ
    fi_secret_room_book_read,   // !ܤɤ
    fi_human_bone_taken,        // ޥɥʥɤι

    //    fi_dragon_library,        // ɥ饴󤬿޽񼼤˽и
    fi_dragon_moved_corridor_2f_r,  // ɥ饴2Fϭˤ
    fi_dragon_moved_entrance_hall,  // ɥ饴󤬸إۡˤ
    fi_dragon_moved_guestroom_1f,   // ɥ饴1FҼˤ
    fi_dragon_in_guestroom_1f,   // ɥ饴1FҼˤ
    fi_dragon_shotdown,       // ɥ饴󤬷Ȥ줿

    fi_toy_lion_taken,
    fi_witch_doll_taken,

	fi_score_found,
	fi_score_taken,
    fi_girl_doll_taken,

	fi_score_set,
	fi_score_played,
	fi_steel_key_found,
	fi_steel_key_taken,

    fi_mirror_put,
    fi_bathroom_ghost_appeared,
	fi_bathroom_2f_ghost_seen,
    fi_bathroom_2f_message_found,
    fi_bathroom_2f_message_read,

//	    fi_amulet_put,
//    fi_memo_taken,

	fi_hall_dining_door_unlocked,
    fi_hall_right_door_unlocked,
    fi_landing_door_unlocked,
    fi_music_room_door_unlocked,


	fi_cycrotron_panel_open,
	fi_cycrotron_small_door_open,
	fi_cycrotron_round_door_open,
	fi_chicken_bone_put,
	fi_human_bone_put,
	fi_rubber_duck_put,
    fi_cycrotron_activated,
    fi_boiler_room_note_read,

	fi_hat_taken,                  // 纴˹Ҥ򽦤ä

    fi_temple_spell_cast,          // ¤ʸ򾧤
	fi_great_old_one_gone,         // ۼԤԤ
    fi_temple_unsunken,            // ¤ο夬
	                               // ۼԤϢư夬ߥ󥰤
								   // Ǥ褦̥ե饰ˤ
    fi_temple_ceiling_destroyed,   // ¤ŷ˲졢ޤ
	fi_temple_burning,             // ˲ФĤ

    fi_temple_exploded,            // ˽ФƤ顢ȯ
    fi_house_burning,              // ߤ˰Ф
    fi_the_end,                    // ǥ󥰥Ф
    fi_dead, // ˴(˴νִ֤ꤹ)
             // ƥȻ¾Υե饰ȶ˥ꥢ

    fi_begin_achievements,
    fi_achievements_cabinet_opened = fi_begin_achievements,
    fi_achievements_door_opened,
    fi_achievements_treasure_chest_unlocked,
    fi_achievements_treasure_chest_opened,
    fi_achievements_chicken_dropped,
    fi_achievements_dog_sitting,
    fi_achievements_wooden_key_taken,
    fi_achievements_duck_moved,
    fi_achievements_duck_gone,
    fi_achievements_sponge_taken,
    fi_achievements_magic_circle_erased,        
    
    fi_achievements_death_completed,
    fi_achievements_progress_completed,
    fi_achievements_complete_completed,
    fi_achievements_alternative_completed,
    fi_achievements_all_completed,
    
    fi_end_achievements,

    fi_end_regular_flags,

    fi_begin_door_flags = 512,
    // ƥɥ򳫤Ȥ뤫ɤ
    fi_hall_dining_door_opened = fi_begin_door_flags,
    fi_hall_left_door_opened,
    fi_hall_right_door_opened,
    fi_bathroom_door_opened,
	fi_dining_living_door_opened,
	fi_dining_kitchen_door_opened,
    fi_kitchen_corridor_door_opened,
    fi_laundry_corridor_door_opened,
    fi_living_corridor_door_opened,
	fi_guestroom_1f_door_opened,
    fi_storage_door_opened,
	fi_playroom_door_opened,
    fi_landing_door_opened,
    fi_boys_room_door_opened,
    fi_girls_room_door_opened,
    fi_ladys_room_door_opened,
    fi_guestroom_2f_door_opened,
    fi_study_corridor_door_opened,
    fi_library_corridor_door_opened,
    fi_bedroom_door_opened,
    fi_music_room_door_opened,
    fi_bathroom_2f_door_opened,
	fi_music_room_right_door_opened,
	fi_balcony_door_opened,
    fi_laundry_cellar_door_opened,
    fi_boiler_room_door_opened,

    fi_end_door_flags,

    fi_begin_discovered_flags = 768,
    // ƥꥢäȤ뤫
    fi_title_discovered,
    fi_game_over_discovered,
	fi_ending_discovered,
    fi_achievements_discovered,

    fi_mailbox_discovered,
    fi_entrance_discovered,
    fi_opened_window_discovered,
    fi_washtub_discovered,
    fi_backdoor_discovered,
    fi_under_tree_discovered,
    fi_garden_discovered,

    fi_entrance_hall_discovered,
    fi_corridor_1f_fl_discovered,
    fi_corridor_1f_bl_discovered,
    fi_corridor_1f_fr_discovered,
    fi_corridor_1f_mr_discovered,
    fi_corridor_1f_br_discovered,
    fi_bathroom_discovered,
    fi_dining_discovered,
    fi_kitchen_discovered,
    fi_laundry_discovered,
    fi_living_discovered,
    fi_guestroom_1f_discovered,
	fi_storage_discovered,
	fi_playroom_discovered,

    fi_landing_discovered,
    fi_corridor_2f_l_discovered,
    fi_corridor_2f_c_discovered,
    fi_corridor_2f_cr_discovered,
    fi_corridor_2f_r_discovered,
	
    fi_boys_room_discovered,
    fi_bed_discovered,
    fi_girls_room_discovered,
    fi_guestroom_2f_discovered,
    fi_study_discovered,
    fi_library_discovered,
    fi_bookshelf_discovered,
    fi_bedroom_discovered,
    fi_ladys_room_discovered,
    fi_wardrobe_discovered,
    fi_secret_room_discovered,
    fi_music_room_discovered,
    fi_bathroom_2f_discovered,
	fi_balcony_discovered,
    fi_balcony_down_discovered,

    fi_cellar_discovered,
    fi_boiler_room_discovered,
    fi_corridor_0f_discovered,
    fi_temple_discovered,
	fi_temple_ceiling_discovered,
	fi_cave_entrance_discovered,
    fi_cave_discovered,
    fi_under_cliff_discovered,

    fi_working_discovered,

    fi_end_discovered_flags,
    fi_end_game_flags = fi_end_discovered_flags,

    // ꥢ४Сꤵե饰(ã)

    // @note ե饰ɲäƤachievementθߴ褦
    // begin_clear_flagsΰ֤ꤷƤ
    // ꥢե饰ΤߥԡǤ褦ˡɬ8ܿˤ
    fi_begin_clear_flags = 1024,
    // 
    fi_death_by_touching_water,  // Ἴο˿줿
    fi_death_by_touching_shadow, // 2FαƤ˿줿
    fi_death_by_armor,           // ˻¤껦줿
    fi_death_by_exiting_window,  // ǿĤˤʤä
    fi_death_by_starvation,      // ǲ
    fi_death_by_tentacle,        // ãǿ˻줿

    // ʲϥꥢΤꤵ(ꥢʤʤãưפ)
    // ꥢˡʣսϡ줾å
    fi_clear_armor_alive,              // ݤƤʤ
    fi_clear_armor_dead,               // ݤ
    fi_clear_treasure_chest_unlocked,  // Ȣ
    fi_clear_treasure_chest_locked,    // Ȣ˸
    fi_clear_portrait_disabled,        // 򳰤ʤä
    fi_clear_portrait_enabled,         // 򳰤
    fi_clear_using_human_bone,         // ޥɥʥɤιǥȥư
    fi_clear_using_chicken_bone,       // ܤιǥȥư
    fi_clear_phone_call_answered,      // ֤ä˽Ф
    fi_clear_phone_call_ignored,       // ֤ä̵뤷

    // οʹ
    fi_death_entered_house,            // ߤä
    fi_death_entered_2f,               // 2Fä
    fi_death_candle_lit,               // Ѥ
    fi_death_magic_circle_invoked,     // ˡؤư
    fi_clear_game,                     // ꥢ

    // Ʊư򤹤٤ƤäƤ뤫
    fi_clear_map_completed,            // ޥåפƥꥢ
    fi_clear_dummy_item_completed,     // ߡƥ򤹤٤Ƽä()
    fi_clear_read_completed,           // ʸ򤹤٤ɤ()
    fi_clear_character_completed,      // طԤλѤ򤹤٤Ƹ
    

    fi_clear_closed,                   // Фʤɤ٤ĤƤ

    fi_end_clear_flags,

    /*
      ã٥ͥ
      ߤĤ֤v
        - ȥȤä
      - 
      - ʸ򤹤٤ɤ?
      - ߡƥ򤹤٤ƤȤä

      v achievementsǤʤ󤫤ȻۼԤФƤƻ
        -> killed by achievements

     */

    fi_end
} flag_id_t;

typedef enum {
    fs_begin = 0,
    fs_dragon = 0, // θɥ饴󤬻
    fs_shadow,     // ȤȱƤ
    // ٥ȤϽиȵԤ̷ˤ
    // ʣγ٥ȤĤǽꡢ
    // Ԥޤ̥٥ȤǤνиαɬפ
    // ǡ
    // - Ʒϳΰ̵֤طȯư
    // - autoʹԻ˳̤ԤʤʹԤʤ(callback᤹)
    // б
    // κݡAΥե饰BǻȤȤɤΥե饰ONˤʤäƤ뤫
    // A, Bν˰¸Ƥޤ
    // ǡ¾ǥåֵԺѤɤפ򤹤٤̷ʬΥ
    // A, Bν˰¸ʤƱͤ˸褦ˤ

    fs_armor_to_guestroom,    // 2FҼ򤤤ȳ
    fs_armor_to_library,      // ޽񼼤򤤤ȳ
    fs_armor_from_guestroom,  // 2FҼ鳻
    fs_armor_from_library,    // ޽񼼤鳻
    fs_end
} flag_sequence_id_t;

typedef struct {
    flag_id_t flags[FLAG_SEQUENCE_MAXLEN];
    int num; // ե饰(status_init()Ǽư׻)
    int is_exclusive; // 0ʤ顢flags[phase]ΤON0ʤ餽ޤǤ٤ON
    int is_auto;      // 0ʤ顢˼ưŪ˿ʹԤ
    int (*callback)(flag_id_t new_flag, int time_passed);
} flag_sequence_t;

typedef struct {
    unsigned char phase; // ƥ֤ʤ顢flags[phase]ޤΩäƤ
    unsigned char bits;
} flag_sequence_status_t;

// ʹʤ0
#define FLAG_SEQUENCE_BIT_ACTIVE 0
// 󥢥ƥ֤ΤȤϢΥ٥ȤǸޤǴλƤʤ0
//                    Ǥƥ٥ϢΤ󥻥뤵Ƥ0
#define FLAG_SEQUENCE_BIT_COMPLETE 1
//// 0ʤ顢˼ưŪ˿ʹԤ
//#define FLAG_SEQUENCE_BIT_AUTO   2

typedef struct {
    flag_id_t id;
    int value;
    int score;
} point_t;

#define FLAG_CHAR_NUM (fi_end/8+1)

#define FLAG_SEQUENCE_MAXNUM 128

typedef struct {
	// area_id_tֻΥǥ򤱤뤿charȤ
	// areag_id255ĶʤȤ
	//    area_id_t current_area;
    unsigned char current_area;
    // ʪθĿ
	unsigned char item_num;
    // ʪnoun_id
    unsigned char items[ITEM_MAX];
    // ƥե饰ξ
    flag_sequence_status_t flag_sequence[FLAG_SEQUENCE_MAXNUM];
    // Ƽե饰
    unsigned char flags[FLAG_CHAR_NUM];
} status_t;


#define Is(f) (is_flag_on(fi_ ## f))
#define Not(f) (is_flag_off(fi_ ## f))
#define Set(f) set_flag(fi_ ## f)
#define Reset(f) reset_flag(fi_ ## f)
#define Toggle(f) toggle_flag(fi_ ## f)
#define TestAndSet(f, msg1, msg2) test_and_set_flag(fi_ ## f, msg1, msg2)
#define TestAndReset(f, msg1, msg2) test_and_reset_flag(fi_ ## f, msg1, msg2)
// condʤե饰fSet, ʤReset
#define Judge(cond, f) ((cond) ? Set(f) : Reset(f))
#define Has(f) (has_item(ni_ ## f))
#define HasNot(f) (!has_item(ni_ ## f))
#define IsActive(fs) (is_flag_sequence_active(fs_ ## fs))
#define NotActive(fs) (!is_flag_sequence_active(fs_ ## fs))
#define Complete(fs) (is_flag_sequence_complete(fs_ ## fs))
#define NotComplete(fs) (!is_flag_sequence_complete(fs_ ## fs))
#define IsCurrentArea(ai) (current_area() == (ai_ ## ai))
#define IsNewArea(ai) (new_area() == (ai_ ## ai))
#define MovingTo(ai) (IsNewArea(ai))
#define MovingFrom(ai) (IsCurrentArea(ai) && !IsNewArea(invalid))
#define Staying(ai) (IsCurrentArea(ai) && IsNewArea(invalid))
#define IsNextArea(ai) (MovingTo(ai) || Staying(ai))

void status_init(void);
void clear_status(void);
void init_achievements_status(void);
area_id_t current_area(void);
void set_area(area_id_t id);
int is_flag_on(flag_id_t fid);
int is_flag_off(flag_id_t fid);
void set_flag(flag_id_t fid);
void reset_flag(flag_id_t fid);
void toggle_flag(flag_id_t fid);
void test_and_set_flag(flag_id_t fid, char *msg_success, char *msg_failure);
void test_and_reset_flag(flag_id_t fid, char *msg_success, char *msg_failure);
int count_on_flags(int num, ...);
int count_on_flags_array(int num, flag_id_t fids[]);
int has_item(noun_id_t nid);
void get_item(noun_id_t nid);
void lose_item(noun_id_t nid);
int get_item_num(void);
noun_id_t get_item_id(int ix);
void show_score(char *msg, point_t points[], int point_num);
void show_normal_score(void);
#ifdef DUMMY
void show_maniac_score(void);
#endif

int load_data(void);
int save_data(void);
int load_achievements_flags(void);
int load_achievements(void);
int save_achievements(void);
int update_achievements(void);
int load_status(char *filename, status_t *status);
int save_status(char *filename, status_t *status);

void clear_flag_sequence(flag_sequence_id_t fs);
void start_flag_sequence(flag_sequence_id_t fs);
void proceed_flag_sequence(flag_sequence_id_t fs);
int jump_flag_sequence(flag_sequence_id_t fs, flag_id_t fid);
void abort_flag_sequence(flag_sequence_id_t fs);
void process_flag_sequences(int time_passed);
//void proceed_auto_flag_sequences(void);
//void callback_flag_sequences(int time_passed);
void set_flag_sequence_active(flag_sequence_id_t fs);
void reset_flag_sequence_active(flag_sequence_id_t fs);
int is_flag_sequence_active(flag_sequence_id_t fs);
void set_flag_sequence_complete(flag_sequence_id_t fs);
int is_flag_sequence_complete(flag_sequence_id_t fs);
//void set_flag_sequence_auto(flag_sequence_id_t fs);
//void reset_flag_sequence_auto(flag_sequence_id_t fs);

int has_light(void);



#endif
