#ifndef TERM_H
#define TERM_H

#include "console.h"
#include "roman_input_line.h"



typedef roman_input_line_mode_t input_mode_t;

int term_init(int lines, int width, int height);
void print_term(char *line);
void puts_term(char *line);
void puts_term_waited(char *line);
void clear_input(void);
void draw_term(void);
void set_term_prompt(char *new_prompt);
input_mode_t get_term_input_mode(void);
void set_term_input_mode(input_mode_t mode);



void set_wait_return_callback(void (*callback)(void));
#endif

