#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include "config.h"
#include "uty.h"



static char *exe_dir;

void init_uty(char *arg0){
    exe_dir = get_exe_dir(arg0);
}


// ARGV[0]Ϥȡ¹ԥեΥǥ쥯ȥ֤
char *get_exe_dir(char *argv0){
    static char dir[EXE_DIR_MAX];
    char *sp = dir;
    char *ep;

    ep = strrchr(argv0, '/');
    // СХѥĤǵưƤ顢ѥʬ֤
    // Win32Ǥargv[0]ϥեѥʤΤǡǽ
    if (ep != NULL){
        while (argv0 != ep+1){
            //            printf("%p %p %c\n", sp, ep, *argv0);
            *sp = *argv0;
            sp ++;
            argv0 ++;
        }
        *sp = '\0';
        return dir;
    }
    // ¹ԥե̾ΤߤξPATH˥å
    else {
        sp = getenv("PATH");
        ep = strchr(sp, ':');
        while (ep != NULL){
            strncpy(dir, sp, ep-sp);
            dir[ep-sp] = '/';
            strcpy(dir + (ep - sp + 1), argv0);
            //            printf("|%s|\n", dir);
            // ѥ˼¹ԥե̾Υե뤬¹°դǤ
            // 줬ȸʤ
            if (access(dir, X_OK) == 0){
                dir[ep-sp+1] = '\0';
                return dir;
            }
            sp = ep + 1;
            ep = strchr(sp, ':');
        }
        return NULL;
    }
}

// pathǼǥ쥯ȥ
// pathκǲؤΥǥ쥯ȥΤߺ롣
//   Υǥ쥯ȥ꤬¸ߤʤмԤ
// 0Ի0֤
int make_dir(char *path){
    return mkdir(path, MAKEDIR_MODE);
}

// ǥ쥯ȥpath¸ߤʤ0֤
int check_dir(char *path){
    struct stat buf;
    // stat()˼Ԥå
    if (stat(path, &buf) != 0){
        return 0;
    }
    else {
        return S_ISDIR(buf.st_mode);
    }
}
