#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_balcony_down(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ΤФΤ褦ʤΤޤƤ롣");
			if (Is(magic_circle_invoked)){
				message("Ф֤褦ˤơ%nl⤫Ӿ夬äƤ롣",
                        ni_magic_circle);
			}
			message("ˤ%nlޤäƤ롣", ni_car);
            return 1;
        case vi_backward:
        case vi_up:
        case vi_exit:
            move_area(ai_balcony);
            return 1;
        default:
            break;
        }
        break;
    case ni_car:
        switch (vid){
        case vi_look:
			message(noun_description(nid));
            message("%nlѤޤƤ롣",
				    ni_drum);
			return 1;
        case vi_examine:
        case vi_remove:
        case vi_move:
        case vi_get:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_open:
        case vi_close:
			msg_too_far();
			return 1;
        default:
            break;
        }
        break;
    case ni_drum:
        switch (vid){
        case vi_look:
            message("椤äѤ¤Ǥ롣",
                    ni_drum);
            return 1;
        case vi_examine:
        case vi_remove:
        case vi_move:
        case vi_get:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_open:
        case vi_close:
        case vi_drink:
			msg_too_far();
			return 1;
        default:
            break;
        }
        break;
    case ni_magic_circle:
        if (Not(magic_circle_invoked)) ReturnNotExist;
        switch (vid){
        case vi_look:
            message("ƤΤƱΤ");
            return 1;
        case vi_examine:
        case vi_remove:
        case vi_move:
        case vi_get:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_open:
        case vi_close:
        case vi_drink:
			msg_too_far();
			return 1;
        default:
            break;
        }
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
