#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_garden(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch (vid){
        case vi_look:
            DescribeArea;
            message("ˤ%nlޤäƤ롣",
                    ni_car);
            return 1;
        case vi_left:
            move_area(ai_entrance);
            return 1;
        case vi_right:
            move_area(ai_under_tree);
            return 1;
        default:
            break;
        }
        break;
    case ni_car:
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            message("ˤϤä%nlѤޤƤ롣",
                    ni_drum);
            return 1;
        case vi_examine:
            message("ޤ֤"
                    "ޤƤʤȤ򸫤ȡ"
                    "ۤĹ֤ƤϤʤ"
                    "纴μ֤");
            return 1;
        case vi_enter:
        case vi_use:
            message("ʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_drum:
        switch (vid){
        case vi_look:
            message("椤äѤ¤Ǥ롣",
                    ni_drum);
            return 1;
        case vi_examine:
            message("ʽ餹ȡȤϥΤ褦");
            return 1;
        case vi_remove:
        case vi_move:
        case vi_get:
            msg_too_heavy();
            return 1;
        case vi_hit:
        case vi_kick:
        case vi_destroy:
            message("Ƥ");
            return 1;
        case vi_open:
        case vi_close:
            message("̤θϷĤޤäƤ롣");
            return 1;
        case vi_drink:
            message("ѤŬȤϻפʤ"
                    "ɤΤߤĤޤäƤƳʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_house:
        message("ظ˷äƤ롣");
        return 1;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
