#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void describe_wardrobe_floor(void);

int area_wardrobe(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
	if (Not(wardrobe_opened)){
		if (vid == vi_forward ||
            // нФ뤳Ȥ˵Ťʤ
            // ɤΤߵĤ֤ϵĤʤ
			vid == vi_load ||
			vid == vi_exit ||
			vid == vi_wait ||
			(vid == vi_open && (nid == ni_door || nid == ni_wardrobe)))
		{
			// ΥޥɤΤ⤬ĤޤäƤƤ(switch˿ʤ)
		}
		else {
			message("ŤƲ⸫ʤ");
			return 1;
		}
	}
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			describe_wardrobe_floor();
            return 1;
        case vi_forward:
        case vi_exit:
			if (Is(wardrobe_opened)){
	            move_area(ai_ladys_room);
			}
			else {
				message("⤬ĤޤäƤ롣");
			}
	        return 1;
        case vi_backward:
			message("ýڤ̤ä̤˹Ԥˤϡ"
					"ʤǯȤ᤮Ƥ롣");
			return 1;
        default:
            break;
        }
        break;
    case ni_door:
    case ni_wardrobe:
        switch(vid){
        case vi_open:
			TestAndSet(wardrobe_opened,
					   "ýڤ򳫤",
					   "ýڤϤ⤦Ƥ롣");
			return 1;
        case vi_close:
            
            if (Is(shadow_in_room) && Is(wardrobe_opened)){
                message("ýڤĤ褦Ȥ\\");
            }
            else {
                  TestAndReset(wardrobe_opened,
					  	 "ýڤĤ",
						 "ýڤĤƤ롣");
            }
			return 1;
        case vi_exit:
			RedoArea(vi_forward, ni_invalid);
        default:
            break;
        }
        break;
    case ni_toy_lion:
		if (has_item(nid)){
			*exist = 0;
			return 0;
		}
        switch(vid){
		case vi_get:
			command_get_item(nid, fi_toy_lion_taken);
			return 1;
		default:
			break;
		}
 		break;
    case ni_witch_doll:
		if (has_item(nid)){
			*exist = 0;
			return 0;
		}
        switch(vid){
		case vi_get:
			command_get_item(nid, fi_witch_doll_taken);
			return 1;
		default:
			break;
		}
 		break;
    case ni_floor:
        switch(vid){
        case vi_look:
			describe_wardrobe_floor();
			return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_ceiling:
		break;
	default:
		*exist = 0;
        break;
    }
    return 0;
}

void describe_wardrobe_floor(void){
	message("ξˤϡ\\");
	if (Not(toy_lion_taken) && 
		Not(witch_doll_taken))
	{
		message("%nl%nlƤ롣",
				ni_toy_lion, ni_witch_doll);		
	}
	else if (Not(toy_lion_taken)){
		message("%nlƤ롣",
				ni_toy_lion);		
	}
	else if (Not(toy_lion_taken)){
		message("%nlƤ롣",
				ni_toy_lion);		
	}
	else {
		message("⤦ʤ");
	}
}


    /*
void post_wardrobe(int time_passed){
	if (!time_passed) return;

	if (Is(shadow_behind_door)){
		if (Is(wardrobe_opened)){
			msg_shadow_in_room();
		}
		else {
			msg_shadow_wandering();
		}
        Reset(shadow_behind_door);
        Set(shadow_in_room);
	}
	else if (Is(shadow_in_room)){
		if (Is(wardrobe_opened)){
	        die_touching_shadow();
		}
		else {
			msg_shadow_left();
	        Reset(shadow_in_room);
			Reset(save_forbidden);
		}
	}
}
    */
