#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_washtub(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ܤˤ礭%nlꡢ"
					"ξˤ%nl롣",
					ni_washtub, ni_window);
            return 1;
        case vi_left:
            move_area(ai_opened_window);
            return 1;
        case vi_right:
            move_area(ai_backdoor);
            return 1;
		case vi_up:
			message("%nnκ٤ΩĤΤϻζȤ",
					ni_washtub);
			return 1;
        default:
            break;
        }
        break;
    case ni_washtub:
		switch (vid){
		case vi_look:
			message("礭%nn"
					"ˤϤäפ%nlίޤäƤ롣",
					ni_washtub, ni_water);
			return 1;
		case vi_examine:
			message("ڤǺ줿ǯʪΤ褦");
			return 1;
		case vi_move:
		case vi_remove:
		case vi_get:
			msg_too_heavy();
			return 1;
		case vi_up:
			RedoArea(vid, ni_invalid);
		default:
			break;
		}
		break;
    case ni_water:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("夬ίޤäΤ");
			return 1;
		case vi_get:
			message("ͤˤŬƴ郎ʤ");
			return 1;
		case vi_drink:
			message("ʤϤȿ"
					"ʢʤȤ褤ġ");
			return 1;
		default:
			break;
		}
		break;
    case ni_window:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("饹Ʒ꤬Ƥ롣");
			return 1;
		default:
			break;
		}
		break;
    case ni_wall:
    case ni_house:
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
