#ifndef MESSAGE_H
#define MESSAGE_H
#include "term.h"
#include "noun.h"


#define MSG_DOOR_UNLOCKED "ȲΩƤθ"
#define MSG_DOOR_ALREADY_UNLOCKED "θϤǤ˳Ƥ롣"
#define JSPELL "दޤΤäĤ㤦äĤˤ̤ʤäܤ줤ꤤ"
#define ESPELL "mumanokizlyaukizninookanakakboleilyqrento"
#define DEBUG_JSPELL "द"
#define DEBUG_ESPELL "muma"

#define Msg(name, str) void msg_ ## name(void){ message(str); }

void message(char *msg, ...);
void set_rest_message(char *rest);
void message_rest(void);


void msg_cannot_do(void);
void msg_cannot_destroy(void);
void msg_cannot_read(void);
void msg_cannot_move(void);
void msg_cannot_climb(void);
void msg_no_effect(void);
void msg_nothing_special(void);
void msg_no_object(void);
void msg_nothing_any_more(void);
void msg_need_to_get(void);
void msg_no_need_to_carry(void);
void msg_which_door(void);
void msg_which_bookshelf(void);
void msg_door_locked(void);
void msg_door_unlocked(void);
void msg_door_unlocked_by_opening(void);
void msg_door_already_unlocked(void);
void msg_door_closed(void);
void msg_door_already_closed(void);
void msg_key_unmatched(void);
void msg_too_large(void);
void msg_too_heavy(void);
void msg_too_far(void);
void msg_combine_unmatched(void);
void msg_bootstrap(void);
void msg_multiple_climb(void);
void msg_armor_standing(void);
void msg_look_standing_armor(void);
void msg_look_standing_armor_sword(void);
void msg_no_magic_circle(void);
void msg_blocked_by_furniture(void);
void msg_no_space_to_move(void);

void msg_to_start(void);
void msg_start(void);
void msg_to_title(void);

void msg_read_newspaper(void);
void msg_look_newspaper(void);
void msg_read_essay(void);
void msg_read_diary(void);
void msg_examine_diary(void);
void msg_read_diary_piece(void);
void msg_read_logbook(void);
void msg_read_postcard(void);
void msg_read_sanders_note(void);
void msg_read_easy_necromancy(void);
void msg_recall_easy_necromancy(void);
void msg_read_yoshino_notebook(void);
void msg_recall_yoshino_notebook(void);
void msg_read_bathroom_1f_wall(void);
void msg_read_mirror(void);
void msg_read_mcdonald_notebook(void);
void msg_recall_mcdonald_notebook(void);
void msg_read_leaflet(void);
void msg_read_letter(void);
void msg_read_secret_room_book(void);
void msg_recall_secret_room_book(void);
void msg_read_bathroom_2f_wall(void);
void msg_read_boiler_room_wall(void);
void msg_recall_boiler_room_wall(void);

//void msg_read_note(void);

void msg_touching_water(void);
void msg_shadow_appeared(void);
void msg_shadow_behind_door(void);
void msg_shadow_approaching(void);
void msg_shadow_in_room(void);
void msg_shadow_in_room_hiding(void);
void msg_touching_shadow(void);
void msg_shadow_wandering(void);
void msg_shadow_gone(void);
void msg_phone_call_started(void);
void msg_phone_call_continued(void);
void msg_phone_call_stopped(void);
void msg_answer_phone_call(void);
void msg_clock_adjusting_guide(void);
void msg_clock_door_opened(void);
void msg_clock_door_closed(void);
void msg_attacked_on_2f(void);
void msg_moved_on_2f(void);
void msg_armor_moving_sound(void);
void msg_armor_moving(void);
void msg_secret_passage(void);
void msg_locked_in_secret_room(void);
void msg_starved(void);
void msg_tentacle_in(void);
void msg_tentacle_death(void);
void msg_tentacle_duck(void);
void msg_tentacle_blocked(void);
void msg_far_door_opened(void);
void msg_armor_into_guestroom(void);
void msg_armor_appeared(void);
void msg_killed_by_armor(void);
void msg_exiting_window(void);
void msg_feeling_magic_circle_power(void);
void msg_looking_pocket_notebook(void);
void msg_no_light(void);
void message_dragon_too_high(noun_id_t nid);
#endif
