#include "status.h"

// ͭ뤿˻ȤˤǾɽ륪֥
#define SHOW_HOUSE 1
#define SHOW_DOOR 1
#define SHOW_FRONT_WINDOW 1
#define SHOW_WINDOW_RIGHT_NEAR 1
#define SHOW_WINDOW_RIGHT_FAR 1
#define SHOW_WINDOW_LEFT_NEAR 1
#define SHOW_WINDOW_LEFT_FAR 1
#define SHOW_CHILD_CHAIR 1
#define SHOW_DINING_CHAIR 1
#define SHOW_GUESTROOM_CHAIR 1
#define SHOW_SINGLE_BED  1
#define SHOW_STUDY_BOOKSHELF 1
#define SHOW_CHEST 1
#define SHOW_CABINET 1
#define SHOW_ROUND_TABLE 1
#define SHOW_DARTS_TARGET 1
#define SHOW_CAR_SIDE 1
#define SHOW_WINDOW_BLOOD 1
#define SHOW_FIREPLACE 1
#define SHOW_PHONE 1
#define SHOW_TREASURE_CHEST_LID 1

// ե饰ξ֤ˤɽɽѤ륪֥
#define SHOW_MAILBOX_LID_CLOSED (Not(mailbox_opened))
#define SHOW_MAILBOX_LID_OPENED (Is(mailbox_opened))
#define SHOW_LETTER (Is(mailbox_opened) && \
                     Not(leaflet_taken))
#define SHOW_MEDAL (Is(mailbox_opened) && \
                    Is(leaflet_taken) && \
                    Not(medal_taken))

#define SHOW_MOVED_FLOWERPOT (Is(flowerpot_moved) && \
							  Not(flowerpot_destroyed))
#define SHOW_FLOWERPOT (Not(flowerpot_moved) && \
                        Not(flowerpot_destroyed))
#define SHOW_FLOWERPOT_FRAGMENTS (Is(flowerpot_destroyed))
#define SHOW_BRASS_KEY (Is(flowerpot_destroyed) && \
					    Not(brass_key_taken))
#define SHOW_WOODEN_KEY ((Is(flowerpot_moved) || \
                          Is(flowerpot_destroyed))&& \
					    Not(wooden_key_taken))

#define SHOW_CLOCK_DOOR_CLOSED (Not(clock_bird_appeared))
#define SHOW_CLOCK_DOOR_OPENED (Is(clock_bird_appeared))
#define SHOW_SILVER_KEY (Is(silver_key_found) && Not(silver_key_taken))
#define SHOW_ASH (Not(silver_key_found))
#define SHOW_FOSSIL_IN_LIVING (Not(fossil_taken))


#define SHOW_BATHTUB_WATER (Not(bathtub_empty))
#define SHOW_BATHTUB_BOTTOM (Is(bathtub_empty))
#define SHOW_BATHTUB_CHAIN (Not(bathtub_empty))
#define SHOW_BATHTUB_CHAIN_REMOVED (Is(bathtub_empty))
#define SHOW_RUBBER_DUCK_FLOATING (Not(bathtub_empty))
#define SHOW_RUBBER_DUCK_DROPPED (Is(bathtub_empty) && \
                                  Not(duck_taken))
#define SHOW_BATHTUB_GLASSES (Is(bathtub_empty) && \
                              Not(glasses_taken))
#define SHOW_MIRROR (Not(mirror_taken))
#define SHOW_SCREW (Not(mirror_taken))
#define SHOW_BATHROOM_MESSAGE (Is(mirror_taken))

#define SHOW_STORAGE_ROUND_TABLE_FAR_LEFT (Not(storage_table_moved))
#define SHOW_STORAGE_ROUND_TABLE_FAR_RIGHT (Is(storage_table_moved))
#define SHOW_STORAGE_CHEST_DRAWERS_OPENED (Not(storage_drawers_closed))
#define SHOW_STORAGE_CHEST_DRAWERS_CLOSED (Is(storage_drawers_closed))


#define SHOW_OVEN_CLOSED (Not(oven_opened))
#define SHOW_OVEN_OPENED (Is(oven_opened))
#define SHOW_CHICKEN_IN_OVEN (Is(oven_opened) && \
                              Not(chicken_taken))

#define SHOW_DINING_CHICKEN (Is(chicken_put))
#define SHOW_DINING_CHICKEN_BONE (Is(candle_lit) && \
								  Not(chicken_put) && \
								  Not(chicken_bone_taken))
#define SHOW_DINING_SWORDMAN (Is(dining_toy_swordman_put))
#define SHOW_DINING_LION (Is(dining_toy_lion_put))
#define SHOW_DINING_BIRD (Is(dining_toy_bird_put))
#define SHOW_DINING_ROBOT (Is(dining_robot_put))
#define SHOW_DINING_DRAGON (Is(dining_toy_dragon_put))
#define SHOW_DINING_LARGE_ROBOT2 (Is(dining_large_robot_put))
#define SHOW_DINING_GLASSES (Is(dining_glasses_put))
#define SHOW_DINING_NECKLACE (Is(dining_necklace_put))
#define SHOW_DINING_PLUSH_CAT (Is(dining_plush_cat_put))
#define SHOW_DINING_FISHING_ROD (Is(dining_fishing_rod_put))
#define SHOW_DINING_BOTTLE (Is(dining_bottle_put))
#define SHOW_DINING_FOSSIL (Is(dining_fossil_put))
#define SHOW_DINING_SCREWDRIVER (Is(dining_screwdriver_put))
#define SHOW_DINING_ANNE_DOLL (Is(dining_girl_doll_put))
#define SHOW_DINING_WITCH_DOLL (Is(dining_witch_doll_put))
#define SHOW_DINING_MARBLE (Is(dining_marble_put))
#define SHOW_DINING_POKER (Is(dining_poker_put))
#define SHOW_DINING_BILLIARD_BALL (Is(dining_billiard_ball_put))
#define SHOW_DINING_RUBBER_DUCK (Is(dining_rubber_duck_put))
#define SHOW_DINING_SLINGSHOT (Is(dining_slingshot_put))
#define SHOW_DINING_LADDER (Is(dining_ladder_put))
#define SHOW_DINING_DIARY (Is(dining_diary_put))
#define SHOW_DINING_SCORE (Is(dining_score_put))
#define SHOW_DINING_ORIGAMI_PLANE (Is(dining_origami_plane_put))
#define SHOW_DINING_ESSAY (Is(dining_essay_put))
#define SHOW_DINING_PAPER (Is(dining_paper_put))
#define SHOW_DINING_LANTERN (Is(dining_lantern_put))
#define SHOW_DINING_MIRROR (Is(dining_mirror_put))
#define SHOW_DINING_MEDAL (Is(dining_medal_put))



#define SHOW_DINING_GHOST (Is(ghost_appeared))
#define SHOW_CANDLE (Not(candle_taken))
#define SHOW_CANDLE_FIRE (Not(candle_taken) && Is(candle_lit))

#define SHOW_DRAGON_FLYING (Is(dragon_in_guestroom_1f) && \
							Not(dragon_shotdown))
#define SHOW_GOLDEN_KEY_FLYING (Is(dragon_in_guestroom_1f) && \
								Not(dragon_shotdown))
#define SHOW_DRAGON_SHOTDOWN (Is(dragon_shotdown) && Not(dragon_taken))
#define SHOW_GOLDEN_KEY_SHOTDOWN (Is(dragon_shotdown) && Not(golden_key_taken))
#define SHOW_GUESTROOM_1F_CABINET_DOOR_CLOSED \
	(Not(guestroom_1f_cabinet_opened))
#define SHOW_GUESTROOM_1F_CABINET_DOOR_OPENED \
	(Is(guestroom_1f_cabinet_opened))
#define SHOW_GUESTROOM_1F_CHAIR_NEAR (Is(guestroom_1f_chair_moved))
#define SHOW_GUESTROOM_1F_CHAIR_FAR (Not(guestroom_1f_chair_moved))
#define SHOW_GUESTROOM_1F_TABLE_NEAR (Is(guestroom_1f_table_moved))
#define SHOW_GUESTROOM_1F_TABLE_FAR (Not(guestroom_1f_table_moved))

#define SHOW_FISHING_ROD (Not(fishing_rod_taken))
#define SHOW_POKER (Not(poker_taken))
#define SHOW_DOG_SITTING (Not(dog_stood_up))
#define SHOW_DOG_STANDING (Is(dog_stood_up) && \
                           Not(dog_gone))
#define SHOW_BELT (Is(dog_gone) && Not(belt_taken))
#define SHOW_WASHER_DOOR_OPENED (Is(washer_opened))
#define SHOW_DRYER_DOOR_OPENED (Is(dryer_opened))

#define SHOW_LANTERN (Not(lantern_taken))

#define SHOW_SECRET_ROOM_BOOK 1
#define SHOW_SECRET_ROOM_LETTER 1
#define SHOW_SECRET_ROOM_SKULL 1
#define SHOW_SECRET_ROOM_NOTEBOOK (Is(pocket_notebook_dropped))
#define SHOW_SECRET_ROOM_CANDLE (Is(candle_put))
#define SHOW_SECRET_ROOM_SHOE_ON (Not(human_bone_taken))
#define SHOW_SECRET_ROOM_SHOE_OFF (Is(human_bone_taken))
#define SHOW_MAGIC_CIRCLE_SYMBOL 1

//#define SHOW_CARD (Not(card_taken))
#define SHOW_PLAYROOM_NOTE 1

#define SHOW_BED_LADDER (Not(ladder_taken))
#define SHOW_TREASURE_CHEST (Not(treasure_chest_moved))
#define SHOW_TREASURE_CHEST_CLOSED (Not(treasure_chest_moved) && \
                           Not(treasure_chest_opened))
#define SHOW_TREASURE_CHEST_OPENED (Not(treasure_chest_moved) && \
                           Is(treasure_chest_opened))
#define SHOW_TREASURE_CHEST_MOVED (Is(treasure_chest_moved))
#define SHOW_TREASURE_CHEST_CLOSED_MOVED \
    (Is(treasure_chest_moved) && \
     Not(treasure_chest_opened))
#define SHOW_TREASURE_CHEST_OPENED_MOVED \
    (Is(treasure_chest_moved) && \
     Is(treasure_chest_opened))
#define SHOW_BILLIARD_BALL (Is(treasure_chest_opened) && \
                     Not(billiard_ball_taken))
#define SHOW_ROBOT_BOX (Is(treasure_chest_opened))
#define SHOW_BROKEN_SLINGSHOT (Is(treasure_chest_moved) && \
                               Not(slingshot_taken))

#define SHOW_MATRESS    (Not(mattress_moved))
#define SHOW_MATRESS_MOVED (Is(mattress_moved))
#define SHOW_PLUSH_CAT (Not(plush_cat_taken) && \
                        Not(mattress_moved))
#define SHOW_PLUSH_CAT_MOVED (Not(plush_cat_taken) && \
                              Is(mattress_moved))
#define SHOW_DIARY (Not(diary_taken))

#define SHOW_ANNE_DOLL (Not(girl_doll_taken))

#define SHOW_SCORE (Is(score_set))

#define SHOW_BATHROOM_2F_MIRROR (Is(mirror_put))
#define SHOW_BATHROOM_2F_GHOST (Is(bathroom_ghost_appeared))

#define SHOW_PORTRAIT_EYES_R (Is(portrait_eyes_right) &&\
                              Not(portrait_removed))
#define SHOW_PORTRAIT_EYES_L (Not(portrait_eyes_right) &&\
                              Not(portrait_removed))
#define SHOW_PORTRAIT (Not(portrait_removed))
#define SHOW_PORTRAIT_REMOVED (Is(portrait_removed))
// ˻Ƥե饰ʹԤin_guestroom뤬
// ξˤ⳻ɽ
#define SHOW_ARMOR_IN_GUESTROOM (Is(armor_in_guestroom) || \
                                 Is(armor_restoring_guestroom)|| \
                                 Is(death_by_armor))
#define SHOW_GUESTROOM_2F_CABINET_DOOR_CLOSED \
	(Not(guestroom_2f_cabinet_opened))
#define SHOW_GUESTROOM_2F_CABINET_DOOR_OPENED \
	(Is(guestroom_2f_cabinet_opened))
#define SHOW_GUESTROOM_2F_CHAIR_NEAR (Not(guestroom_2f_chair_moved))
#define SHOW_GUESTROOM_2F_CHAIR_FAR (Is(guestroom_2f_chair_moved))
#define SHOW_GUESTROOM_2F_TABLE_NEAR (Not(guestroom_2f_table_moved))
#define SHOW_GUESTROOM_2F_TABLE_FAR (Is(guestroom_2f_table_moved))
#define SHOW_GUESTROOM_BOOK_ONTABLE (Not(guestroom_2f_book_moved))
#define SHOW_GUESTROOM_BOOK_ONCABINET (Is(guestroom_2f_book_moved))
#define SHOW_LOGBOOK_ONTABLE (Not(guestroom_2f_book_moved))
//                                      Not(logbook_taken))
#define SHOW_LOGBOOK_ONCABINET (Is(guestroom_2f_book_moved))
//                                      Not(logbook_taken))
#define SHOW_BOTTLE (Is(guestroom_2f_cabinet_opened) && Not(bottle_taken))
#define SHOW_SPONGE (Is(guestroom_2f_cabinet_opened) && Not(sponge_taken))

#define SHOW_BEDROOM_DRAWERS_CLOSED (Not(bedroom_drawers_opened))
#define SHOW_BEDROOM_DRAWERS_OPENED (Is(bedroom_drawers_opened))
#define SHOW_MARBLE (Is(marble_found) && Not(marble_taken))


#define SHOW_WARDROBE_DOOR_CLOSED (Not(wardrobe_opened))
#define SHOW_WARDROBE_DOOR_OPENED (Is(wardrobe_opened))
#define SHOW_BRANCH (Not(branch_taken))
#define SHOW_NECKLACE (Is(dressing_table_opened) && \
                       Not(necklace_taken))
#define SHOW_DRESSING_TABLE_DRAWER (Not(dressing_table_opened))
#define SHOW_DRESSING_TABLE_DRAWER_OPENED \
    (Is(dressing_table_opened))

#define SHOW_TOY_LION (Not(toy_lion_taken) &&\
                       Is(wardrobe_opened))
#define SHOW_WITCH_DOLL (Not(witch_doll_taken) &&\
                         Is(wardrobe_opened))
#define SHOW_WARDROBE_INSIDE (Is(wardrobe_opened))

//#define SHOW_STUDY_ARMOR_SITTING (Not(armor_in_study) && Not(armor_dead))
#define SHOW_STUDY_ARMOR_SITTING (Not(armor_moving) && Not(armor_dead))
#define SHOW_ARMOR_IN_STUDY (Is(armor_in_study))

#define SHOW_STUDY_LIBRARY_DOOR_OPENED (Not(study_library_door_closed))
#define SHOW_STUDY_LIBRARY_DOOR_CLOSED (Is(study_library_door_closed))
#define SHOW_STUDY_CHAIR (Not(study_desk_opened))
#define SHOW_STUDY_CHAIR_MOVED (Is(study_desk_opened))
#define SHOW_STUDY_DESK_DRAWER (Not(study_desk_opened))
#define SHOW_STUDY_DESK_DRAWER_OPENED (Is(study_desk_opened))
/*
#define SHOW_AMULET (Is(study_desk_opened) &&\
                       Not(amulet_taken))
*/
#define SHOW_SCREWDRIVER (Is(study_desk_opened) &&\
                          Not(screwdriver_taken))
//#define SHOW_POSTCARD (Not(postcard_taken))
#define SHOW_POSTCARD 1
#define SHOW_STUDY_NOTEBOOK (Is(study_desk_opened))

#define SHOW_LIBRARY_STUDY_DOOR_OPENED (Not(study_library_door_closed))
#define SHOW_LIBRARY_STUDY_DOOR_CLOSED (Is(study_library_door_closed))
#define SHOW_STUDY_FROM_LIBRARY (Not(study_library_door_closed))
#define SHOW_LIBRARY_ARMOR_SITTING (Not(study_library_door_closed) && \
                                    Not(armor_moving) &&              \
                                    Not(armor_dead) &&                \
                                    Not(death_by_armor))

//                                    Not(armor_in_library) &&          
//                                    Not(armor_crushed) &&             
//                                    Not(armor_crushed) &&             
#define SHOW_LIBRARY_KEY      (NotActive(dragon) && NotComplete(dragon))
// ˻Ƥե饰ʹԤin_library뤬
// ξˤ⳻ɽ
//#define SHOW_ARMOR_IN_LIBRARY (Is(armor_in_library) || Is(death_by_armor))
#define SHOW_ARMOR_IN_LIBRARY (Is(armor_in_library) || \
                               Is(armor_restoring_library))
#define SHOW_LIBRARY_BOOKSHELF_NEAR (Not(bookshelf_moved))
#define SHOW_LIBRARY_BOOKSHELF_FAR (Is(bookshelf_moved))
#define SHOW_LIBRARY_BOOK (Not(bookshelf_book_removed) && Not(bookshelf_moved))
#define SHOW_BOOKSHELF_HANDLE_LOCKED (Is(bookshelf_book_removed) && \
									  Not(bookshelf_moved) && \
									  Not(bookshelf_unlocked))
#define SHOW_BOOKSHELF_HANDLE_UNLOCKED (Is(bookshelf_book_removed) && \
								  	    Not(bookshelf_moved) && \
									    Is(bookshelf_unlocked))
#define SHOW_LADDER_LIBRARY (Is(library_ladder_set))
#define SHOW_ORIGAMI_PLANE_LIBRARY (Not(origami_plane_taken))
#define SHOW_FOSSIL_IN_LIBRARY (Is(fossil_set))
#define SHOW_ARMOR_CRUSHED (Is(armor_crushed) ||     \
                            Is(armor_reviving) ||    \
                            Is(armor_dead))

#define SHOW_ORIGAMI_PLANE (Not(origami_plane_taken))

//#define SHOW_AMULET_PUT (Is(amulet_put))
#define SHOW_MAGIC_CIRCLE_INVOKED (Is(magic_circle_invoked))

#define SHOW_CAR_TOP 1
#define SHOW_GARDEN_MAGIC_CIRCLE (Is(magic_circle_invoked) && \
                                  Is(cycrotron_activated))
#define SHOW_GARDEN_SYMBOLS (Is(magic_circle_invoked) &&   \
                             Is(cycrotron_activated))

#define SHOW_BOILER_ROOM_MESSAGE 1
#define SHOW_CYCROTRON_PANEL_CLOSED (Not(cycrotron_panel_open))
#define SHOW_CYCROTRON_PANEL_OPENED (Is(cycrotron_panel_open))
#define SHOW_CYCROTRON_CABLE_DOWN (Is(cycrotron_panel_open) && \
								   Not(rubber_duck_put))
#define SHOW_CYCROTRON_CABLE_UP (Is(cycrotron_panel_open) && \
								 Is(rubber_duck_put))
#define SHOW_CYCROTRON_RUBBER_DUCK  (Is(cycrotron_panel_open) && \
									 Is(rubber_duck_put))
#define SHOW_CYCROTRON_SMALL_DOOR_CLOSED (Not(cycrotron_small_door_open))
#define SHOW_CYCROTRON_SMALL_DOOR_OPENED (Is(cycrotron_small_door_open))
#define SHOW_CYCROTRON_CHICKEN_BONE (Is(cycrotron_small_door_open) && \
									 Is(chicken_bone_put))
#define SHOW_CYCROTRON_HUMAN_BONE (Is(cycrotron_small_door_open) && \
                                   Is(human_bone_put))
#define SHOW_CYCROTRON_ROUND_DOOR_CLOSED (Not(cycrotron_round_door_open))
#define SHOW_CYCROTRON_ROUND_DOOR_OPENED (Is(cycrotron_round_door_open))
#define SHOW_CYCROTRON_FUEL_ROD (Is(cycrotron_round_door_open))
#define SHOW_CYCROTRON_METER_OFF (Not(cycrotron_activated))
#define SHOW_CYCROTRON_METER_ON (Is(cycrotron_activated))


#define SHOW_HAT (Not(hat_taken))

#define SHOW_TEMPLE_PILLARS (Is(temple_unsunken))
#define SHOW_TEMPLE_PILLARS_SUNKEN (Not(temple_unsunken))
#define SHOW_TEMPLE_STAIRS (Is(temple_unsunken))
#define SHOW_TEMPLE_STAIRS_SUNKEN (Not(temple_unsunken))
#define SHOW_TEMPLE_WATER (Not(temple_unsunken))
#define SHOW_TEMPLE_FLOOR (Is(temple_unsunken))

#define SHOW_GREAT_OLD_ONE_BODY_SUNKEN (Not(temple_unsunken))
#define SHOW_GREAT_OLD_ONE_BODY (Is(temple_unsunken))
#define SHOW_GREAT_OLD_ONE_FACES 1
#define SHOW_TENTACLES_F (Is(temple_unsunken))
#define SHOW_TENTACLES_B_DOWN (Is(temple_unsunken) && \
										     Not(temple_burning))
#define SHOW_TENTACLES_B_UP (Is(temple_unsunken) && \
										   Is(temple_burning))
#define SHOW_TENTACLES_F_SUNKEN (Not(temple_unsunken))
#define SHOW_TENTACLES_B_SUNKEN (Not(temple_unsunken))
#define SHOW_TEMPLE_WAVE (Not(temple_unsunken))
#define SHOW_TEMPLE_OIL_POOL (Is(temple_ceiling_destroyed))
#define SHOW_TEMPLE_OIL_FLOW (Is(temple_ceiling_destroyed))
#define SHOW_TEMPLE_CAR (Is(temple_ceiling_destroyed))
#define SHOW_TEMPLE_FLAME (Is(temple_unsunken) && \
						   Is(temple_burning))

#define SHOW_CAVE_EXIT 1
#define SHOW_UNDER_CLIFF_TEMPLE_FLAME (Is(temple_exploded))
#define SHOW_UNDER_CLIFF_HOUSE_FLAME (Is(house_burning))

#define SHOW_ACHIEVEMENTS_GLASSES (Is(death_by_touching_water))
#define SHOW_ACHIEVEMENTS_NECKLACE (Is(death_by_touching_shadow))
#define SHOW_ACHIEVEMENTS_ARMOR_SITTING (Is(death_by_armor))
#define SHOW_ACHIEVEMENTS_SLINGSHOT (Is(death_by_exiting_window))
#define SHOW_ACHIEVEMENTS_SKULL (Is(death_by_starvation))
#define SHOW_ACHIEVEMENTS_TENTACLE (Is(death_by_tentacle))


#define SHOW_ACHIEVEMENTS_FOSSIL (Is(clear_armor_alive) &&\
                                  Is(clear_armor_dead))
#define SHOW_ACHIEVEMENTS_PORTRAIT (Is(clear_portrait_enabled) &&\
                                    Is(clear_portrait_disabled))
#define SHOW_ACHIEVEMENTS_PORTRAIT_EYES SHOW_ACHIEVEMENTS_PORTRAIT
#define SHOW_ACHIEVEMENTS_BILLIARD_BALL \
    (Is(clear_treasure_chest_unlocked) &&                               \
     Is(clear_treasure_chest_locked))
#define SHOW_ACHIEVEMENTS_HUMAN_BONE (Is(clear_using_human_bone) &&\
                                      Is(clear_using_chicken_bone))
#define SHOW_ACHIEVEMENTS_PHONE (Is(clear_phone_call_answered) &&\
                                  Is(clear_phone_call_ignored))

#define SHOW_ACHIEVEMENTS_TREASURE_CHEST 1
#define SHOW_ACHIEVEMENTS_TREASURE_CHEST_CLOSED \
    (Not(achievements_treasure_chest_opened))
#define SHOW_ACHIEVEMENTS_TREASURE_CHEST_OPENED \
    (Is(achievements_treasure_chest_opened))
#define SHOW_ACHIEVEMENTS_LANTERN (Is(clear_map_completed))
#define SHOW_ACHIEVEMENTS_ANNE_DOLL (Is(clear_dummy_item_completed))
#define SHOW_ACHIEVEMENTS_WITCH_DOLL (Is(clear_read_completed)) 
#define SHOW_ACHIEVEMENTS_LARGE_ROBOT (Is(clear_character_completed))
#define SHOW_ACHIEVEMENTS_MAGIC_CIRCLE \
    (Is(achievements_all_completed) && \
     Not(achievements_magic_circle_erased))
#define SHOW_ACHIEVEMENTS_MAGIC_CIRCLE_SYMBOL SHOW_ACHIEVEMENTS_MAGIC_CIRCLE
#define SHOW_ACHIEVEMENTS_SPONGE (Is(achievements_cabinet_opened) &&\
                                  Not(achievements_sponge_taken))
#define SHOW_ACHIEVEMENTS_DUCK_IN_CHEST \
    (Is(achievements_treasure_chest_opened) && \
     Not(achievements_duck_moved) && \
     Not(achievements_duck_gone))
#define SHOW_ACHIEVEMENTS_DUCK_ON_DOG \
    (Is(achievements_treasure_chest_opened) && \
     Is(achievements_duck_moved) && \
     Not(achievements_duck_gone))


#define SHOW_ACHIEVEMENTS_CABINET_DOOR_CLOSED \
    (Not(achievements_cabinet_opened))
#define SHOW_ACHIEVEMENTS_CABINET_DOOR_OPENED \
    (Is(achievements_cabinet_opened))
#define SHOW_ACHIEVEMENTS_WOODEN_KEY            \
    (Is(achievements_cabinet_opened) &&         \
     Not(achievements_wooden_key_taken))
#define SHOW_ACHIEVEMENTS_FLOWERPOT (Is(death_entered_house))
#define SHOW_ACHIEVEMENTS_FISHING_ROD (Is(death_entered_2f))
#define SHOW_ACHIEVEMENTS_CANDLE (Is(death_candle_lit))
#define SHOW_ACHIEVEMENTS_CANDLE_FIRE SHOW_ACHIEVEMENTS_CANDLE
#define SHOW_ACHIEVEMENTS_BOTTLE (Is(death_magic_circle_invoked))
#define SHOW_ACHIEVEMENTS_AMULET (Is(clear_game))

//#define SHOW_ACHIEVEMENTS_CAR 1
//#define SHOW_ACHIEVEMENTS_CAR_CHAIN SHOW_ACHIEVEMENTS_CAR

#define SHOW_ACHIEVEMENTS_DOOR_CLOSED (Not(achievements_door_opened))
#define SHOW_ACHIEVEMENTS_DOOR_OPENED (Is(achievements_door_opened))

#define SHOW_ACHIEVEMENTS_CHICKEN (Is(achievements_chicken_dropped))
#define SHOW_ACHIEVEMENTS_DOG_SITTING (Is(achievements_dog_sitting))
#define SHOW_ACHIEVEMENTS_DOG_STANDING (Not(achievements_dog_sitting))

#define SHOW_ACHIEVEMENTS_MIRROR (Is(achievements_death_completed))
#define SHOW_ACHIEVEMENTS_SCREW SHOW_ACHIEVEMENTS_MIRROR
#define SHOW_ACHIEVEMENTS_TARGET (Is(achievements_progress_completed))
#define SHOW_ACHIEVEMENTS_WINDOW (Is(achievements_alternative_completed))
#define SHOW_ACHIEVEMENTS_CAT (Is(achievements_complete_completed))
#define SHOW_ACHIEVEMENTS_CHAIN SHOW_ACHIEVEMENTS_CAT


#define SHOW_ACHIEVEMENTS_GREAT_OLD_ONE \
    (Is(achievements_door_opened) && \
     (Not(achievements_all_completed) || \
      Is(achievements_magic_circle_erased)))
#define SHOW_ACHIEVEMENTS_GREAT_OLD_ONE_BLOCKED \
    (Is(achievements_door_opened) && \
     (Is(achievements_all_completed) && \
      Not(achievements_magic_circle_erased)))


#define SHOW_ACHIEVEMENTS 1
#define SHOW_ACHIEVEMENTS_HIDE 0
#define SHOW_UNDER_CLIFF_THE_END (Is(the_end))
#define SHOW_THE_END 1

//#define SHOW_LIBRARY_BOOKSHELF_MOVED (Is(bookshelf_moved))
